/**
 * FontFace (allows changing of colours and font faces)
 * $Id: FontFace.java,v 1.11 2003/10/18 02:23:42 jeffnik Exp $
 */

/* JamochaMUD, a Muck/Mud client program
 * Copyright (C) 1998-2004  Jeff Robinson
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package anecho.JamochaMUD;

import java.awt.*;
import java.awt.event.*;

// import java.util.Hashtable;

import anecho.gui.ColourPicker;
// import anecho.gui.PosTools;
import anecho.gui.ResReader;
// import anecho.gui.SyncFrame;

/**
 * FontFace (allows changing of colours and font faces)
 * @version $Id: FontFace.java,v 1.11 2003/10/18 02:23:42 jeffnik Exp $
 * @author Jeff Robinson
 */
public class FontFace_pre_Netbeans extends Dialog implements ActionListener, MouseListener{
	private Button okayButton, cancelButton, fontColourButton, bgColourButton;
        private Color bgColour, fontColour;
        private Font currentFont;
	private Choice fontBody, fontStyle, fontSize;
        private Frame parentFrame;
        private TextField sampleText;
        // private int a;
        // private Panel fFPanel, fFsubPanel1, fFsubPanel2, fFsubPanel3, fFsubPanel4, fFsubPanel5;
        private JMConfig settings;

	static FontFace editIt;
						
        public FontFace_pre_Netbeans(JMConfig settings, Frame frameParent, Color foreGround, Color backGround, Font mainFontFace) {
            super(frameParent, "JamochaMUD - "+ RB("FontFace.title"), true);

            this.parentFrame = frameParent;       // Needed to call other dialogues
            this.bgColour = backGround;
            this.fontColour = foreGround;
            this.currentFont = mainFontFace;
            this.settings = settings;

            // fFPanel = new Panel();
            // fFsubPanel1 = new Panel();
            // fFsubPanel2 = new Panel();
            // fFsubPanel3 = new Panel();
            // fFsubPanel4 = new Panel();
            // fFsubPanel5 = new Panel();
            fontBody = new Choice();
            fontStyle = new Choice();
            fontSize = new Choice();

            // Set Gridbag layout
            GridBagLayout fFLayout = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            this.setLayout(fFLayout);

            // Add dialogue components
            Label fFLabel = new Label(RB("font"));
            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 0;
            constraints.gridy = 0;
            constraints.insets = new Insets(7, 7, 2, 2);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(fFLabel, constraints);
            add(fFLabel);

            fontBody = new Choice();

            /* Old technique
            fontBody.add("Serif");
            fontBody.add("SansSerif");
            fontBody.add("Monospaced");
            fontBody.add("Dialog");
            */

            if (settings.getJMboolean(settings.USESWING)) {
                // Swing support!
                java.awt.GraphicsEnvironment ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
                String[] names = ge.getAvailableFontFamilyNames();
                for ( int i=0; i < names.length; i++ ) {
                    // System.out.println( names[i] );
                    fontBody.add(names[i]);
                }
            } else {
                // No Swing support
                String[] names = java.awt.Toolkit.getDefaultToolkit().getFontList();
                for ( int i=0; i < names.length; i++ ) {
                    // System.out.println( names[i] );
                    fontBody.add(names[i]);
                }
            }

            // Determine existing name style, and make that default choice
            fontBody.select(currentFont.getName());

            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 2;
            constraints.gridy = 0;
            constraints.insets = new Insets(7, 2, 2, 2);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(fontBody, constraints);
            add(fontBody);
            fontBody.addMouseListener(this);

            fontStyle = new Choice();

            fontStyle.add(RB("plain"));
            fontStyle.add(RB("bold"));
            fontStyle.add(RB("italic"));
            fontStyle.add(RB("bold&italic"));

            // Determine existing font style, and make it the default choice
            fontStyle.select(currentFont.getStyle());
            // fFsubPanel1.add(fontStyle);
            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 4;
            constraints.gridy = 0;
            constraints.insets = new Insets(7, 2, 2, 7);
            constraints.fill = GridBagConstraints.BOTH;
            constraints.gridwidth = GridBagConstraints.RELATIVE;
            fFLayout.setConstraints(fontStyle, constraints);
            add(fontStyle);
            fontStyle.addMouseListener(this);

            fFLabel = new Label(RB("fontSize"));
            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 1;
            constraints.gridy = 1;
            constraints.insets = new Insets(2, 7, 2, 2);
            constraints.fill = GridBagConstraints.BOTH;
            // constraints.gridwidth = GridBagConstraints.RELATIVE;
            fFLayout.setConstraints(fFLabel, constraints);
            add(fFLabel);

            fontSize = new Choice();
            for (int fs = 6; fs < 41; fs++) {
                fontSize.add(fs + "");
            }
            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 3;
            constraints.gridy = 1;
            constraints.insets = new Insets(2, 2, 2, 7);
            constraints.anchor = GridBagConstraints.WEST;
            constraints.gridwidth = GridBagConstraints.RELATIVE;
            fFLayout.setConstraints(fontSize, constraints);

            fontSize.select(currentFont.getSize() - 6);
            add(fontSize);

            fFLabel = new Label(RB("change"));
            constraints.gridwidth = 3;
            constraints.gridheight = 1;
            constraints.gridx = 0;
            constraints.gridy = 2;
            constraints.insets = new Insets(2, 7, 2, 2);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(fFLabel, constraints);
            add(fFLabel);

            fontColourButton = new Button(RB("fontColour"));
            constraints.gridwidth = 3;
            constraints.gridheight = 1;
            constraints.gridx = 3;
            constraints.gridy = 2;
            constraints.insets = new Insets(2, 2, 2, 7);
            constraints.fill = GridBagConstraints.BOTH;
            constraints.gridwidth = GridBagConstraints.RELATIVE;
            fFLayout.setConstraints(fontColourButton, constraints);
            fontColourButton.addActionListener(this);
            add(fontColourButton);

            fFLabel = new Label(RB("change"));
            constraints.gridwidth = 3;
            constraints.gridheight = 1;
            constraints.gridx = 0;
            constraints.gridy = 3;
            constraints.insets = new Insets(2, 7, 2, 2);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(fFLabel, constraints);
            add(fFLabel);

            bgColourButton = new Button(RB("backgroundColour"));
            constraints.gridwidth = 3;
            constraints.gridheight = 1;
            constraints.gridx = 3;
            constraints.gridy = 3;
            constraints.insets = new Insets(2, 2, 2, 7);
            constraints.fill = GridBagConstraints.BOTH;
            constraints.gridwidth = GridBagConstraints.RELATIVE;
            fFLayout.setConstraints(bgColourButton, constraints);
            add(bgColourButton);
            bgColourButton.addActionListener(this);

            fFLabel = new Label("");
            constraints.gridwidth = 6;
            constraints.gridheight = 1;
            constraints.gridx = 0;
            constraints.gridy = 4;
            constraints.fill = GridBagConstraints.BOTH;
            constraints.gridwidth = GridBagConstraints.RELATIVE;
            fFLayout.setConstraints(fFLabel, constraints);

            okayButton = new Button(RB("okay"));
            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 1;
            constraints.gridy = 5;
            constraints.insets = new Insets(7, 7, 7, 7);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(okayButton, constraints);
            add(okayButton);
            okayButton.addActionListener(this);

            cancelButton = new Button(RB("cancel"));
            constraints.gridwidth = 2;
            constraints.gridheight = 1;
            constraints.gridx = 4;
            constraints.gridy = 5;
            constraints.insets = new Insets(7, 7, 7, 7);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(cancelButton, constraints);
            add(cancelButton);
            cancelButton.addActionListener(this);

            sampleText = new TextField(RB("thePleasingRedFoxSipped"));
            constraints.gridwidth = GridBagConstraints.REMAINDER;
            constraints.gridheight = 1;
            constraints.gridx = 0;
            constraints.gridy = 6;
            constraints.insets = new Insets(7, 7, 7, 7);
            constraints.fill = GridBagConstraints.BOTH;
            fFLayout.setConstraints(sampleText, constraints);
            add(sampleText);
            pack();
        }                                              

	/**
	 * This is a generic bit to access the
	 * ResReader.class, for localization
	 * (Multi-language support)
         */
        private static String RB(String itemTarget) {
            ResReader reader = new ResReader();
            // return reader.LangString("JamochaMUDBundle", itemTarget);
            return reader.LangString(JMConfig.BUNDLEBASE, itemTarget);
        }

	public void actionPerformed(ActionEvent event){
		String arg = event.getActionCommand();

                if (arg.equals(fontColourButton.getLabel())) {
                    Color tempColour = callColourChooser(RB("fontColour"), fontColour);
                    /*
                    ColourPicker picker = new ColourPicker(parentFrame, "Font Colour", fontColour);
                    picker.setVisible(true);

                    Color tempColour = picker.getColour();
                    */

                    if (tempColour != null) {
                        fontColour = tempColour;
                    }
		}

                if (arg.equals(bgColourButton.getLabel())) {
                    Color tempColour = callColourChooser(RB("backgroundColour"), bgColour);
                    /*
                     ColourPicker picker = new ColourPicker(parentFrame, "Background Colour", bgColour);
                     picker.setVisible(true);

                     Color tempColour = picker.getColour();
                     */

                    if (tempColour != null) {
                        bgColour = tempColour;
                    }
		}

		if (arg.equals(okayButton.getLabel())){
                    // Okay was selected, get the information
                    JMSetNewColour();
                    // Get information from fontBody and fontStyle, and apply them
                    setVisible(false);

                    // Write to the .jamocha.rc file
                    dispose();
		}
                if (arg.equals(cancelButton.getLabel())){
                    JMSetCancelledColour();
                    setVisible(false);
                    dispose();
		}
		repaint();
	}

	// Mouse events
	public void mousePressed(MouseEvent mevt) {}

	public void mouseReleased(MouseEvent mevt) {
		repaint();
	}

        public void mouseClicked(MouseEvent mevt) {
		repaint();
	}

	public void mouseEntered(MouseEvent mevt) {}

	public void mouseExited(MouseEvent mevt) {}

	/**
	 * Update the sample text
	 */
        public void paint(Graphics graph) {
            int body = fontBody.getSelectedIndex();
            int style = fontStyle.getSelectedIndex();
            Font tempFont = new Font(fontBody.getItem(body), style, 12);
            sampleText.setBackground(bgColour);
            sampleText.setForeground(fontColour);
            sampleText.setFont(tempFont);
            /*
            graph.setColor(bgColour);
            graph.fill3DRect(25, 210, 250, 30, true);
            graph.setColor(fontColour);
            graph.setFont(tempFont);
            graph.drawString(RB("thePleasingRedFoxSipped"), 40, 230);
            */
	}

	/** 
	 * Apply the new colour and face as chosen by the user
	 */
	private void JMSetNewColour() {
            // Get information from fontBody and fontStyle, and apply them
            // int a = fontStyle.getSelectedIndex();
            int body = fontBody.getSelectedIndex();
            int style = fontStyle.getSelectedIndex();
            int size = fontSize.getSelectedIndex() + 6;

            currentFont = new Font(fontBody.getItem(body), style, size);
        }

        /** Set our currentFont to null, so we know the user
         * cancelled any changes that were made */
        private void JMSetCancelledColour() {
            currentFont = (Font)null;
        }

        /** Return our font */
        public Font getFontStyle() {
            return currentFont;
        }

        public Color getForegroundColour() {
            return fontColour;
        }

        public Color getBackgroundColour() {
            return bgColour;
        }

        /** Choose the appropriate colour chooser depending on the API */
        private Color callColourChooser(String title, Color initialColour) {
            Color retColour = new Color(0, 0, 0);

            if (settings.getJMboolean(JMConfig.USESWING)) {
                retColour = javax.swing.JColorChooser.showDialog(parentFrame, title, initialColour);
            } else {
                ColourPicker picker = new ColourPicker(parentFrame, title, initialColour);
                picker.setVisible(true);

                retColour = picker.getColour();
            }

            return retColour;
        }
}
